<?php

use App\Domain\Categories\Models\PropertyType;
use App\Domain\Classifiers\Enums\MetricsCategory;
use App\Domain\Classifiers\Enums\ProductFlag;
use App\Domain\Classifiers\Enums\ProductStatus;
use App\Domain\Classifiers\Enums\ProductType;
use App\Http\ApiV1\OpenApiGenerated\Enums\MetricsCategoryEnum;
use App\Http\ApiV1\OpenApiGenerated\Enums\ProductFlagEnum;
use App\Http\ApiV1\OpenApiGenerated\Enums\ProductStatusEnum;
use App\Http\ApiV1\OpenApiGenerated\Enums\ProductTypeEnum;
use App\Http\ApiV1\OpenApiGenerated\Enums\PropertyTypeEnum;
use Tests\UnitTestCase;

uses(UnitTestCase::class)->group('support', 'unit');

test('PropertyTypeEnum has the same elements as PropertyType', function ($value) {
    expect(PropertyType::from($value))->not->toBeNull();
})->with(PropertyTypeEnum::cases());

test('ProductTypeEnum has the same elements as ProductType', function ($value) {
    expect(ProductType::tryFrom($value))->not->toBeNull();
})->with(ProductTypeEnum::cases());

test('ProductStatusEnum has the same elements as ProductStatus', function ($value) {
    expect(ProductStatus::tryFrom($value))->not->toBeNull();
})->with(ProductStatusEnum::cases());

test('MetricsCategoryEnum has the same elements as MetricsCategory', function ($value) {
    expect(MetricsCategory::tryFrom($value))->not->toBeNull();
})->with(MetricsCategoryEnum::cases());

test('ProductFlagEnum has the same elements as ProductFlag', function ($value) {
    expect(ProductFlag::tryFrom($value))->not->toBeNull();
})->with(ProductFlagEnum::cases());
